/* global AddSearchClient, AddSearchUI */
var client = new AddSearchClient('4405e9985bdfa504962e98a138a66dfd');
client.setPaging(1, 15, 'relevance', 'desc');
client.setSearchOperator('and');

var conf = {
  matchAllQuery: false
};


// Get the relative path to the landing page of this doc by finding its link in the TOC.
// It always has the id="m-". We stash it in the window object so it is available wherever.
homeLink = $("nav#td-section-nav").find("a.tree-root")[0].href;
// Strip any trailing slash, because the URLs send back from addSearch always contain a leading
// slash.
window.homeLink = homeLink.endsWith('/') ? homeLink.slice(0, -1) : homeLink;
// Build URL for the search results page relative to the home path.
conf.searchResultsPageUrl = window.homeLink + '/searchResults.html';

var searchui = new AddSearchUI(client, conf);

var suggestionClient = new AddSearchClient('4405e9985bdfa504962e98a138a66dfd');
suggestionClient.setPaging(1, 10, 'relevance', 'desc');

var suggestionClientRelated = new AddSearchClient('4405e9985bdfa504962e98a138a66dfd');
suggestionClientRelated.setPaging(1, 5, 'relevance', 'desc');

client.addFacetField('custom_fields.categories');
client.addFacetField('custom_fields.tags');
client.addFacetField('custom_fields.type');
suggestionClient.addFacetField('custom_fields.type');

// Templates
var autocompleteTemplate = `
  <div class="addsearch-autocomplete">
   {{#gt suggestions.length 0}}
   <div class="adds-suggestions-main-wrapper">  
    <ul class="suggestions adds-suggestions-container">
      {{#each ../suggestions}}
        <li class="adds-suggestion" data-keyword="{{value}}" data-index="{{@index}}" {{#equals ../../activeSuggestionIndex @index}}class="active"{{/equals}}>
          {{value}}
        </li>
      {{/each}}
    </ul>
   </div>
  {{/gt}}
  </div>
`;

var searchResultTemplate = `
   <div class="addsearch-searchresults">    
    {{#if resultcount}}
      {{> numberOfResultsTemplate }}
    {{/if}}
    <div class="adds-hits-main-wrapper">
    {{#each hits}}
    <a href="{{url}}" data-analytics-click="{{id}}"  class="adds-hit adds-search-results-link hit-{{custom_fields.type}}-type" 
           onclick="handleClick('{{url}}'); return false;" >
      <div class="adds-hit{{#equals type "PROMOTED"}} promoted{{/equals}}">
        <div class="adds-hit-wrapper" {{#if style}} style="background-color:{{style.background_color}}"{{/if}}>
            <div class="adds-hit-bottom">
              <h2 class="adds-hit-title" {{#if style}} style="color:{{style.text_color}}"{{/if}}>
                {{title}}
              </h2>
              <div class="adds-highlight" {{#if style}} style="color:{{style.text_color}}"{{/if}}>        
               {{#if custom_fields.summary}}{{custom_fields.summary}}{{else}}{{{highlight}}}{{#not type "PROMOTED"}}&#8230;{{/not}}{{/if}}
              </div>
            </div>
          </div>
        </div>
      </a>
    {{/each}}
    </div>
  </div>
`;

var searchFieldTemplate = `
  <div class="addsearch-searchfield-container">
    <form class="addsearch-searchfield" autocomplete="off" action="?" role="search">
      <div class="search-field-wrapper">     
        <input type="search" placeholder="{{placeholder}}" aria-label="Search field" class="{{#not icon false}}icon{{/not}} addsearch" />
      </div>
      {{#if button}}
        <button type="button" aria-label="Search button" >{{button}}</button>
      {{/if}}
    </form>
  </div>
`;

const NUMBER_OF_RESULTS_TEMPLATE = `
  <div class="number-of-results">
    {{#gt page 1}}Page {{../page}} of {{/gt}}
    {{total_hits}}{{#equals total_hits 10000}}+{{/equals}} results for <em>{{keyword}}</em>
  </div>
`;

function createFacetTemplate(name) {
  return `   
     <div class="addsearch-facets adds-filters-group">
      {{#if facets}}
      <div class="adds-filter-title">
        ${name}
        <span class="adds-open-group-icon"></span>
       </div>
       {{/if}}
        <ul class="adds-filter-parent-container">
         {{#each facets}}
          <li  data-facet="{{value}}" class="adds-sub-filter-title">
            <label class="adds-label">
              <input type="checkbox" value="{{value}}" class="adds-checkbox" />
              <span class="adds-value">{{value}}</span> <em class="adds-count">({{count}})</em>
            </label>
          </li>
          {{/each}}
       </ul>
    </div>
  `
}

// Add components

if (document.getElementById('autocomplete-container')) {
  searchui.autocomplete({
    containerId: 'autocomplete-container',
    template: autocompleteTemplate,
    hideAutomatically: true,
    // onShow: alignAutocomplete,
    sources: [
      {
        type: AddSearchUI.AUTOCOMPLETE_TYPE.SUGGESTIONS,
        client: suggestionClientRelated,
        jsonKey: 'results'
      }
    ]
  });
}

searchui.searchField({
  containerId: 'searchfield-container',
  placeholder: 'Keyword..',
  // button: 'Search',
  icon: true,
  searchAsYouType: !!document.getElementById('searchresults-container'),
  template: searchFieldTemplate
});

if (document.getElementById('sortby')) {
  searchui.sortBy({
    containerId: 'sortby',
    options: [
      {
        label: 'Relevance',
        sortBy: 'relevance',
        order: 'desc'
      },
      {
        label: 'Title A-Z',
        sortBy: 'custom_fields.customTitle',
        order: 'asc'
      },
      {
        label: 'Title Z-A',
        sortBy: 'custom_fields.customTitle',
        order: 'desc'
      }
    ]
  });
}

if (document.getElementById('searchresults-container')) {
  searchui.searchResults({
    containerId: 'searchresults-container',
    template: searchResultTemplate,
    template_resultcount: NUMBER_OF_RESULTS_TEMPLATE
  });
}

if (document.getElementById('selected-filters-container')) {
  searchui.activeFilters({
    containerId: 'selected-filters-container'
  });
}

if (document.getElementById('facets-container-category')) {
  var filterTemplateCategories = createFacetTemplate('Category');
  searchui.facets({
    containerId: 'facets-container-categories',
    field: 'custom_fields.categories',
    sticky: true,
    template: filterTemplateCategories
  });
}

if (document.getElementById('facets-container-type')) {
  var filterTemplateTags = createFacetTemplate('Type');
  searchui.facets({
    containerId: 'facets-container-type',
    field: 'custom_fields.type',
    sticky: true,
    template: filterTemplateTags
  });
}

if (document.getElementById('facets-container-tags')) {
  var filterTemplateTags = createFacetTemplate('Tags');
  searchui.facets({
    containerId: 'facets-container-tags',
    field: 'custom_fields.tags',
    sticky: true,
    template: filterTemplateTags
  });
}



if (document.getElementById('pagination-container')) {
  searchui.pagination({
    containerId: 'pagination-container'
  });
}

// All components added. Start
searchui.start();

// Event listeners
if (document.querySelector('#autocomplete-container')) {
  document.addEventListener('click', () => searchui.hideAutocomplete());
  document.querySelector('#autocomplete-container').addEventListener('click', (e) => e.stopPropagation());
  document.querySelector('#searchfield-container').addEventListener('click', (e) => e.stopPropagation());

  window.showAllResultBtn = function () {
    document.querySelector('.addsearch-searchfield button').click();
  };
}

document.addEventListener('click', function(event) {
  if (!event.target || (!event.target.classList.contains('adds-open-sub-group-icon') &&
    !event.target.classList.contains('adds-filter-title') &&
    !event.target.classList.contains('adds-open-group-icon'))) {
    return;
  }
  if (event.target.classList.contains('adds-filter-title')) {
    toggleClassName(event.target.parentElement, 'adds-shrink');
  }
  if (event.target.classList.contains('adds-open-sub-group-icon') || event.target.classList.contains('adds-open-group-icon')) {
    toggleClassName(event.target.parentElement.parentElement, 'adds-shrink');
  }
});

function toggleClassName(element, classname) {
  if (element.classList.contains(classname)) {
    element.classList.remove(classname);
  } else {
    element.classList.add(classname);
  }
}

var mobileFilterToggle = document.querySelector('.adds-filter-toggle');
if (mobileFilterToggle) {
  mobileFilterToggle.addEventListener('click', function () {
    toggleClassName(document.querySelector('.adds-filters-main-wrapper'), 'adds-close');
  });
}

function handleClick(url) {
  // If we have a relative link, prepend the path to the homepage to properly redirect.
  if (url.startsWith('http:') || url.startsWith('https:')) {
    // No need to change
    window.location.href = url;
  } else {
    var destination = window.homeLink + url;
    window.location.href = destination;
  }
}
