// Hack to add previous/next buttons 

$(document).ready(function () {
    var thisPage = $('#td-sidebar-nav-active-item').parents('li').first();
    var nextLI;
    var prevLI;
    if (thisPage.length) {
      // Determine the next and previous topics.
  
      // Start with next. 
      // If this element has children, then we choose the first child element to be next.
      if (thisPage.has("ul").length) {
        nextLI = thisPage.children('ul').children('li').first()
      }
      // See if we have a sibling 
      else if (thisPage.next("li").length) {
        nextLI = thisPage.next("li");
      }
      // See if our parent has a sibling
      else if (thisPage.parents("li").first().next("li").length) {
        nextLI = thisPage.parents("li").first().next("li");
      }
      else {
        // No next. Must be at the end of the doc.
        nextLI = null;
      }
  
      // Now get previous. Easiest option, see if there is a previous sibling.
      if (thisPage.prev("li").length) {
        sibling = thisPage.prev("li")
        // Special case, if the sibling has a children, we need to go
        // down as far as we can to get the lowest entry.
        // Note: This won't work for top-level topics, because the links aren't actually
        // there in the page.
        if (sibling.has("ul").length) {
          while (sibling.has("ul").length) {
            sibling = sibling.children("ul")
          }
          prevLI = sibling.children('li').last()
        } else {
          // simple case, previous sibling
          prevLI = thisPage.prev("li");
        }
      }
      // Check for parent LI item
      else if (thisPage.parents("li").length) {
        prevLI = thisPage.parents("li")
      } else {
        // No other option... must be the homepage?
        prevLI = null;
      }
      if (prevLI || nextLI) {
  
        var tdContent = $(".td-content");
  
        tdContent.attr("tabindex", 1);  // Focus the main content to allow for keyboard nav.
        tdContent.css("outline", "none"); // Hide box highlighting the main content when focused
        tdContent.delay(100).focus();  // Force focus on main content
  
  
        var prevLink = '';
        var nextLink = '';
  
        if (prevLI) {
          prevLink = `<a id="prev_page_button" href="${prevLI.children("a").first().attr("href")}" aria-label="Previous Page" class="btn btn-primary" style="color: white;
                font-weight: bold;" accesskey="p"><span class="mr-1">←</span>Previous Page</a>`
  
          console.log("Prev link: " + prevLI.children("a").attr("href"));
        }
        if (nextLI) {
          nextLink = `<a id="next_page_button" href="${nextLI.children("a").attr("href")}" aria-label="Next Page" class="btn btn-primary" style="color: white;
                font-weight: bold;" accesskey="n">Next Page <span class="ml-1" >→</span></a>`;
          console.log("Next link: " + nextLI.children("a").attr("href"));
        }
        var linkContainer = `<ul class="list-unstyled d-flex justify-content-between align-items-center mb-0 pt-5" style="list-style-type: none;">
            <li>
              ${prevLink}
            </li>
              ${nextLink}
            </li>
            </ul>`;
        tdContent.append(linkContainer);
      }
    }
  
  });
  
  