
function getCookie(cookieName) {
  var name = cookieName + "=";
  var decodedCookie = decodeURIComponent(document.cookie);
  var cookieArray = decodedCookie.split(';');
  for (var i = 0; i < cookieArray.length; i++) {
    var c = cookieArray[i].trim();
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return "";
}

function setCookie(cookieName, value) {
  document.cookie = cookieName + "=" + value + ";expires=3153600000;path=/";
}


$(function () {

  // toc and sidebar
  var mainSize = 8;
  $('#hide-left-btn').click(function () {
    if ($(this).is(':checked')) {
      mainSize -= 2;
      $('aside.col-12').show();
      setCookie('leftHidden', 'false');
    } else {
      mainSize += 2;

      $('aside.col-12').hide();
      setCookie('leftHidden', 'true');
      $('#hide-left-div').offset({ left: 0 });
    }
    $('body main').attr('class', `col-12 col-md-9 col-xl-${mainSize} pl-md-5`);
    positionCollapseButtons();
  });

  $('#hide-right-btn').click(function () {
    if ($(this).is(':checked')) {
      mainSize -= 2;
      $('aside.d-none').attr('style', 'display:block !important;');
      $('#hide-right-btn-label').text("Hide Right Column");
      setCookie('rightHidden', 'false');
    } else {
      mainSize += 2;
      $('aside.d-none').attr('style', 'display:none !important;');
      $('#hide-right-btn-label').text("Show Right Column");
      setCookie('rightHidden', 'true');
    }
    $('body main').attr('class', `col-12 col-md-9 col-xl-${mainSize} pl-md-5`);
    positionCollapseButtons();
  });
  // On page load, read the cookies and click either of the hide buttons if the column is hidden.
  if (getCookie('leftHidden') == "true") {
    $('#hide-left-btn').click();
  }
  if (getCookie('rightHidden') == "true") {
    $('#hide-right-btn').click();
  } else {
    $('aside.d-none').attr('style', 'display:block');
  }

  // Gets the visible height of an element in the browser viewport. 
  function heightInView($el) {
    var elH = $el.outerHeight(),
      H = $(window).height(),
      r = $el[0].getBoundingClientRect(), t = r.top, b = r.bottom;
    return Math.max(0, t > 0 ? Math.min(elH, H - t) : Math.min(b, H));
  }

  // Reposition collapse buttons
  function positionCollapseButtons() {
    var leftAside = $('aside.col-12');
    var rightAside = $('aside.d-none');
    var hideLeftBtn = $('#hide-left-div');
    var hideRightBtn = $('#hide-right-div');
    var tdMain = $('main.col-12');
    var leftBtnImg = $('#left_hide_btn_image');
    var rightBtnImg = $('#right_hide_btn_image');
    var leftPos = "";
    var rightPos = "";
    // Left button horizontal position depends on whether left column is visible.
    if (leftAside.is(':visible')) {
      leftPos = leftAside.width() + 25 + "px";
      leftBtnImg.addClass('spinIcon');
      hideLeftBtn.tooltip('dispose');
      hideLeftBtn.tooltip({ 'placement': 'right', 'title': 'Collapse left column' });
    } else {
      leftPos = "0px";
      leftBtnImg.removeClass('spinIcon');
      hideLeftBtn.tooltip('dispose');
      hideLeftBtn.tooltip({ 'placement': 'right', 'title': 'Show left column' });
    }

    if (rightAside.is(':visible')) {
      rightPos = rightAside.width() + 20 + "px";
      rightBtnImg.removeClass('spinIcon');
      hideRightBtn.tooltip('dispose');
      hideRightBtn.tooltip({ 'placement': 'left', 'title': 'Collapse right column' });
    } else {
      rightPos = "0px";
      rightBtnImg.addClass('spinIcon');
      hideRightBtn.tooltip('dispose');
      hideRightBtn.tooltip({ 'placement': 'left', 'title': 'Show right column' });
    }

    // Buttons are positioned 1/2 height of visible area (given by the main container) minus half the
    // height of the button.
    var displayMidpoint = heightInView(tdMain) / 2 - hideLeftBtn.height() / 2;

    hideLeftBtn.css({
      left: leftPos,
      top: `${displayMidpoint}px`
    });

    hideRightBtn.css({
      right: rightPos,
      top: `${displayMidpoint}px`
    });

  }

  function moveSearchBox() {
    // 
    const width = Math.max(
      document.documentElement.clientWidth,
      window.innerWidth || 0
    )
    // default to the parent being the navbar banner.
    var parent_element = 'div.navbar-nav';

    if (width < 800) {
      // When in mobile view, we move the search box to the mobile div.
      parent_element = 'form.td-sidebar__search';
    } else if (width < 960) {
      // Tablet mode, move to under the main tag.
      parent_element = 'main.col-12';
    }
    current_parent = $('#searchbox').parent();
    parent_html = $('#searchbox').parent().innerHTML;
    console.log('Search box parent'+parent_html)
    // See if the parent we need is already the parent of the box
    if (!$(parent_element).is($('#searchbox').parent())){
      // Nope, move it.
      console.log('Moving search box');
      $(parent_element).prepend($('#searchbox'));
    }

    
  }

  // Call position function when page finishes loading
  $(document).ready(function () {
    positionCollapseButtons();
    moveSearchBox();
  });

  // Edge case. A resize of the window that shrinks it down to the point of triggering small or xs bootstrap layout
  // causes the right show/hide button to disappear. This means if the left column is collapsed when the user shrinks
  // the browser, we lose the hamburger menu (which is in the left column). So, if we trigger the lower sizes, we need
  // to force the left column to unhide. When we expand, we can re-hided the side panel.

  // Set up a timer to wait until the screen resize is most likely done.

  var winResizeTimer;
  window.onresize = function () {
    clearTimeout(winResizeTimer);
    winResizeTimer = setTimeout(winWasResized, 50);
  };

  function winWasResized() {
    // Haven't resized in 100ms, assume user is through.
    const width = Math.max(
      document.documentElement.clientWidth,
      window.innerWidth || 0
    )
    if (width <= 768) {
      // Window is narrow enough to trigger "small" layout, so show the left column if hidden.
      if (getCookie('leftHidden') == 'true') {
        $('aside.col-12').show();
      }
    } else {
      if (getCookie('leftHidden') == 'true') {
        $('aside.col-12').hide();
      }
    }
    // Reposition buttons if necessary
    positionCollapseButtons();
    // See if we need to move search box.
    moveSearchBox();
  }

});

// Highlight the current heading in the right-hand nav.

var highlightedHead = null;  // Track heading that is highlighted.

window.addEventListener("load", (event) => {
  createObserver();
}, false);

function createObserver() {
  let observer;

  let options = {
    root: null,
    rootMargin: '5px 5px -50%'
  };

  // #TableOfContents > ul:nth-child(1) > li:nth-child(1)
  // #TableOfContents > ul:nth-child(1) > li:nth-child(1) > a:nth-child(1)


  observer = new IntersectionObserver((entries, observer) => {
    // loop twice. Once to ensure we have an active item. Then if we do, we loop again to enable the active and
    // disable any inactive.
    var visible = {};
    var haveActive = false;

    entries.forEach(entry => {
      const id = entry.target.getAttribute('id');
      if (entry.intersectionRatio > 0) {
        visible[id] = true;
        haveActive = true;
      } else {
        visible[id] = false;
      }
    });



    // Only update if at least one heading is active.
    if (haveActive) {
      for (var toc_entry in visible) {
        if (visible[toc_entry]) {
          if (highlightedHead == toc_entry) {
            break;  // Active heading is highlighted. Nothing to do.
          }
          var activeHead = document.querySelector(`nav li a[href="#${toc_entry}"]`);
          if (activeHead) {
            activeHead.classList.add('activeToc');

            activeHead.scrollIntoView({
              // behavior: "smooth",
              block: 'nearest',
              //inline: 'start'
            });

          }
          if (highlightedHead != null) {
            if (document.querySelector(`nav li a[href="#${highlightedHead}"]`) != null) {
              document.querySelector(`nav li a[href="#${highlightedHead}"]`).classList.remove('activeToc');
            }
          }
          highlightedHead = toc_entry;
          break;
        }
      }
    }

  }, options);
  document.querySelectorAll('h2[id], h3[id]').forEach((section) => {
    observer.observe(section);
  });
}

